var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import React, { useEffect, useRef } from 'react';
var Table = function (props) {
    var _a;
    var _b = React.useState('loading'), status = _b[0], setStatus = _b[1];
    var _c = React.useState([]), tableData = _c[0], setTableData = _c[1];
    var chartRef = useRef(null);
    var getChartDataAsync = function (arg) { return __awaiter(void 0, void 0, void 0, function () {
        var result, _a;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    _b.trys.push([0, 2, , 3]);
                    return [4, props.configuration.fnGetChartDataAsync(arg)];
                case 1:
                    result = _b.sent();
                    if ((result === null || result === void 0 ? void 0 : result.length) === 0) {
                        setStatus('empty');
                        setTableData([]);
                    }
                    else {
                        setStatus('loaded');
                        setTableData(result);
                    }
                    return [3, 3];
                case 2:
                    _a = _b.sent();
                    setStatus('error');
                    setTableData([]);
                    return [3, 3];
                case 3: return [2];
            }
        });
    }); };
    useEffect(function () {
        getChartDataAsync({ id: props.configuration.setup.id });
    }, []);
    useEffect(function () {
        var handleResize = function () {
            if (chartRef.current) {
                chartRef.current.getEchartsInstance().resize();
            }
        };
        window.addEventListener('resize', handleResize);
        return function () {
            window.removeEventListener('resize', handleResize);
        };
    }, []);
    if (status === 'empty') {
        if (props.configuration.emptyComponentChartItem)
            return props.configuration.emptyComponentChartItem;
        return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-empty", children: _jsx("h1", { children: "No data for table" }) }));
    }
    if (status === 'loading') {
        if (props.configuration.loadingComponentChartItem)
            return props.configuration.loadingComponentChartItem;
        return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-loading", children: _jsx("h1", { children: "Loading data table..." }) }));
    }
    if (status === 'error') {
        if (props.configuration.errorComponentChartItem)
            return props.configuration.errorComponentChartItem;
        return (_jsx("div", { className: "s-dashboard-item s-dashboard-item-error", children: _jsx("h1", { children: "Error data table" }) }));
    }
    var tableColumnsOption = Array.isArray((_a = props.configuration.setup.table) === null || _a === void 0 ? void 0 : _a.columns)
        ? props.configuration.setup.table.columns
        : [];
    var arrayHeaders = tableColumnsOption
        .map(function (option) {
        return option.header_text;
    })
        .filter(function (header) { return header !== null && header !== undefined; }) ||
        Object.keys(tableData[0]) ||
        [];
    return (_jsxs("table", { border: 1, className: "table-component", style: { width: '100%', borderCollapse: 'collapse' }, children: [_jsx("thead", { children: _jsx("tr", { style: { backgroundColor: '#f5f7fa' }, children: arrayHeaders.map(function (col) { return (_jsx("th", { children: col }, col)); }) }) }), _jsx("tbody", { children: tableData.map(function (row, index) {
                    var _a, _b, _c, _d, _e, _f, _g, _h, _j;
                    return (_jsx("tr", { style: {
                            minWidth: (_a = tableColumnsOption[index].width) !== null && _a !== void 0 ? _a : 'auto',
                            textAlign: (_c = (_b = tableColumnsOption[index].styles) === null || _b === void 0 ? void 0 : _b.text_align) !== null && _c !== void 0 ? _c : 'left',
                            fontStyle: ((_d = tableColumnsOption[index].styles) === null || _d === void 0 ? void 0 : _d.italic) ? 'italic' : 'normal',
                            fontWeight: ((_e = tableColumnsOption[index].styles) === null || _e === void 0 ? void 0 : _e.bold) ? 'bold' : 'normal',
                            color: (_g = (_f = tableColumnsOption[index].styles) === null || _f === void 0 ? void 0 : _f.text_color) !== null && _g !== void 0 ? _g : '#000',
                            backgroundColor: ((_j = (_h = tableColumnsOption[index].styles) === null || _h === void 0 ? void 0 : _h.bg_color) !== null && _j !== void 0 ? _j : index % 2 === 0) ? '#fafafa' : '#ffffff',
                        }, children: arrayHeaders.map(function (col) { return (_jsx("td", { className: "border px-4 py-2", children: row[col] }, col)); }) }, index));
                }) })] }));
};
export default Table;
